function Decomp2Excel(decomp,labelsy,xlsfile)

% Input
% decomp:  the decomposition file outputted by the simply.m
% lablesy: a string array of names of the variables
% xlsfile:  the name of the xls where to write the results

% Copyright 2013 Biosystems Data Analysis Group; Universiteit van Amsterdam
%
% This is a license to use and modify SOFTWARE & DATA produced by:
% THE BIOSYSTEMS DATA ANALYSIS GROUP OF THE UNIVERSITEIT VAN AMSTERDAM

% If you use, modify or redistribute the SOFTWARE & DATA and/or your source modifications, you agree:
% i)	to use the SOFTWARE & DATA and/or your source modifications solely as part of your research and not in any commercial product;
%
% ii)	that the SOFTWARE  & DATA and/or your source modifications will not be distributed for profit;

% iii)	all copyright notices and this license note with the SOFTWARE & DATA are retained any  redistribution of the SOFTWARE & DATA, or any portion thereof;
%
% iv)	to indemnify, hold harmless, and defend the "Biosystems Data Analysis Group of the Universiteit van Amsterdam" from and against any claims or lawsuits that arise or result from the use of the SOFTWARE & DATA or your source modifications.
%
% v)	to properly reference the SOFTWARE & DATA when used in your reseach in any publication that may result from that research.
%
% Reserved Rights. The "Biosystems Data Analysis Group of the Universiteit
% van Amsterdam" retain title and all ownership rights to the SOFTWARE & DATA.




%Excel settings
range = {'A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1', 'K1', 'L1',...
    'M1', 'N1', 'O1', 'P1', 'Q1', 'R1', 'S1', 'T1', 'U1', 'V1', 'W1', 'X1', 'Y1', 'Z1'};
warning off MATLAB:xlswrite:AddSheet;

disp(sprintf('Writing results of simplivariate decomposition to excel file: %s',xlsfile));

if size(range,2) < size(decomp,2)
    error('You must have as many sheets as simply component!\n You must add range values at line 29 of Decomp2Excel.m')
end



for L = 1 : size(decomp,2)
    
    Layer = decomp{L};
    myvar = Layer.tau;
    
    M = {};
    M{1} = char(sprintf('SimplyComp %i',L));
    
    p = 0;
    for i = 1:length(myvar)
        if myvar(i) > 0
            p = p+1;
            
            M{p+1} = char(labelsy(i));
            
        end
    end
    
    
    xlswrite(xlsfile,cellstr(M(:,:)'),'Simplivariate Decomposition',range{L});
    
end

warning on MATLAB:xlswrite:AddSheet;

excelFilePath = pwd; % Current working directory.
sheetName = 'Sheet'; 

% Open Excel file.
objExcel = actxserver('Excel.Application');
objExcel.Workbooks.Open(fullfile(excelFilePath,xlsfile)); 
% Delete sheets.
try
% Throws an error if the sheets do not exist.
objExcel.ActiveWorkbook.Worksheets.Item([sheetName '1']).Delete;
objExcel.ActiveWorkbook.Worksheets.Item([sheetName '2']).Delete;
objExcel.ActiveWorkbook.Worksheets.Item([sheetName '3']).Delete;
catch
; % Do nothing.
end

% Save, close and clean up.
objExcel.ActiveWorkbook.Save;
objExcel.ActiveWorkbook.Close;
objExcel.Quit;
objExcel.delete;



disp('Results written on file!')




return