
function showDecomp(decomp_dc, labelsy)

% Copyright 2013 Biosystems Data Analysis Group; Universiteit van Amsterdam
%
% This is a license to use and modify SOFTWARE & DATA produced by:
% THE BIOSYSTEMS DATA ANALYSIS GROUP OF THE UNIVERSITEIT VAN AMSTERDAM

% If you use, modify or redistribute the SOFTWARE & DATA and/or your source modifications, you agree: 
% i)	to use the SOFTWARE & DATA and/or your source modifications solely as part of your research and not in any commercial product; 
%	
% ii)	that the SOFTWARE  & DATA and/or your source modifications will not be distributed for profit; 

% iii)	all copyright notices and this license note with the SOFTWARE & DATA are retained any  redistribution of the SOFTWARE & DATA, or any portion thereof; 
%
% iv)	to indemnify, hold harmless, and defend the "Biosystems Data Analysis Group of the Universiteit van Amsterdam" from and against any claims or lawsuits that arise or result from the use of the SOFTWARE & DATA or your source modifications. 
%
% v)	to properly reference the SOFTWARE & DATA when used in your reseach in any publication that may result from that research.
%	
% Reserved Rights. The "Biosystems Data Analysis Group of the Universiteit
% van Amsterdam" retain title and all ownership rights to the SOFTWARE & DATA.


best=[];
for i=1:size(decomp_dc,2)
    best(:, i)=[decomp_dc{i}.tau];
end

h2=cpdff2n(size(best,2));

new_index=[];
for j=1:size(h2,1)
    for i=1:size(best,1)
        if (sum(best(i,:)==h2(j,:))==size(best,2))
            new_index(end+1)=i;
        end
    end
end

newlabelsy=labelsy(new_index);

best=best(new_index, :);


id = min(find(best(:,end)==1));

BEST = best(id:end,:);
BESTLAB = newlabelsy(id:end);

figure
set(gcf, 'Position', [452 164 697 400]);


imagesc(BEST);
set(gca, 'Ytick', 1:size(BEST,1));
set(gca, 'YTickLabel', BESTLAB);

set(gca, 'Xtick', 0:1:size(BEST,2));
for i=0:size(BEST,1)
    labelsx{i+1}=['Comp ' num2str(i)];
end

labelsx=labelsx';
set(gca, 'XTickLabel', labelsx);
colormap([1 1 1; 0 0 0;]);
colorbar;
title(sprintf('The %i components of the simplivariate decomposition',size(decomp_dc,2)))
return

function x = cpdff2n(n)

rows = 2.^(n);
ncycles = rows;
x = zeros(rows,n);

for k = 1:n
    settings = (0:1);
    ncycles = ncycles/2;
    nreps = rows./(2*ncycles);
    if (k~=n)
        settings = settings(ones(1,nreps),:);
        settings = [settings(:); settings(end:-1:1)'];
        settings = settings(:,ones(1,ncycles/2)); 
        x(:,n-k+1) = settings(:);
    else
        settings = settings(ones(1,nreps),:);
        settings = settings(:);
        settings = settings(:,ones(1,ncycles));
        x(:,n-k+1) = settings(:);
    end
end

return



